MODULE Mach2OS;

(*
 *  Ersetzt eine Rechnerangabe in den Benutzerdaten durch eine
 *  Betriebssystemangabe
 *
 *  0.1    29.10.97    - erste ffentliche Version
 *)

FROM     SYSTEM            IMPORT   BYTE, ADR;
FROM     System            IMPORT   GetArg, Terminate;
FROM     Storage           IMPORT   ALLOCATE, DEALLOCATE;
IMPORT   Directories;
FROM     Directories       IMPORT   DirQuery, DirEntry, GetCurDir, ChDir;
FROM     FileIO            IMPORT   File;
IMPORT   FileIO;
FROM     Files             IMPORT   READ, IO, WRITE, NORMAL,
                                    Open, Create, Close, Read, Write,
                                    SeekMode, Seek, Rename, FileStatus;
IMPORT   InOut;
FROM     Strings           IMPORT   Append, Delete, Length, Pos,
                                    CompareStr, Concat;
FROM     Strings1          IMPORT   Assign, Upper, Capital, P2MString,
                                    M2PString, Fill,
                                    RemoveTrailingSpaces, CorrectPath;
FROM     ASCII             IMPORT   CR, LF, EOF;
IMPORT   Display;
FROM     NumberConversion  IMPORT   CardToString, StringToCard, IntToString,
                                    StringToInt;
FROM     TimeNDate         IMPORT   Time, Date, TimeFormat, DateFormat,
                                    GetTime, GetDate, TimeToStr, DateToStr;
FROM     MausLibrary       IMPORT   Boolean, String8, String10, String15, String20,
                                    String25, String30, String40, String65,
                                    String70, String127, tGruppenFlags, GruppenStr,
                                    TGruppenRec, GrpSetMax, GruppenMax, tGruppenSet,
                                    sizeGSet, IstInGruppe, InclGruppe,
                                    TBenutzerprofil, MausPath;
IMPORT   ConfigFile;
IMPORT   void;

VAR      userPath:      String127;
         debug,
         verbose,
         test,
         error,
         help:          BOOLEAN;
         date:          Date;
         time:          Time;
         dateStr:       ARRAY [0 .. 11] OF CHAR;
         path:          String127;
         crlf:          ARRAY [0 .. 1] OF CHAR;
         outfile:       File;

CONST    BITSETSPER64BYTE = (256 DIV (SIZE(BITSET)*8));
         UserFile =  "MUSER.DAT";
         UserFiles=  "MU*.DAT";


PROCEDURE WriteLine(file: INTEGER; str: ARRAY OF CHAR);
BEGIN
   Write(file, ADR(str), Length(str), void.cardinal);
   Write(file, ADR(crlf), 2, void.cardinal);
END WriteLine;

PROCEDURE IsTrue(bool: Boolean): BOOLEAN;
BEGIN
   RETURN ORD(bool)>0;
END IsTrue;

PROCEDURE DisplayCard(card: CARDINAL);
VAR str: ARRAY [0 .. 5] OF CHAR;
BEGIN
   CardToString(card, str, 6);
   Display.Write(str[0]);
   Display.Write(str[1]);
   Display.Write(str[2]);
   Display.Write(str[3]);
   Display.Write(str[4]);
   Display.Write(str[5]);
   Display.Write(CR);
END DisplayCard;

PROCEDURE Machine2OS(VAR str: ARRAY OF CHAR): BOOLEAN;
VAR result:  BOOLEAN;
    rechner: ARRAY [0 .. 10] OF CHAR;
BEGIN
  result := TRUE;
  Assign(str, rechner);
  Upper(rechner);
  IF Pos('PC ', rechner)<10 THEN
    Assign('DOS', str);
  ELSIF Pos('AT ', rechner)<10 THEN
    Assign('DOS', str);
  ELSIF Pos('386ER', rechner)<10 THEN
    Assign('DOS', str);
  ELSIF Pos('486ER', rechner)<10 THEN
    Assign('DOS', str);
  ELSIF Pos('PENTIUM', rechner)<10 THEN
    Assign('DOS', str);
  ELSIF Pos('P1', rechner)<10 THEN
    Assign('DOS', str);
  ELSIF Pos('P2', rechner)<10 THEN
    Assign('DOS', str);
  ELSIF Pos('MACINTOSH', rechner)<10 THEN
    Assign('Mac OS', str);
  ELSIF Pos('ATARI', rechner)<10 THEN
    Assign('TOS/MagiC', str);
  ELSIF Pos('AMIGA', rechner)<10 THEN
    Assign('Amiga OS', str);
  ELSIF Pos('ARCHIMEDES', rechner)<10 THEN
    Assign('RiscOS', str);
  ELSIF Pos('ACORN', rechner)<10 THEN
    Assign('RiscOS', str);
  ELSE
     result := FALSE;
  END;
  RETURN result;
END Machine2OS;

PROCEDURE MUDATScannen(fileEntry: DirEntry);
VAR   file:    INTEGER;
      written,
      read:    CARDINAL;
      user:    TBenutzerprofil;
      offset:  LONGCARD;
      output:  String70;
      count:   CARDINAL;
      line,
      column:  CARDINAL;
      buffer,
      name:    ARRAY [0 .. 41] OF CHAR;
      changed: BOOLEAN;
      i:       CARDINAL;
BEGIN
   IF test THEN
      Open(file, fileEntry.name, READ);
   ELSE
      Open(file, fileEntry.name, IO);
   END;
   IF file>=0 THEN
      count := 0;
      REPEAT
         Read(file, ADR(user), 1024 (*SIZE(user)*), read);
         IF read=1024 (*SIZE(user)*) THEN
            changed := FALSE;
            DisplayCard(count);
            IF user.Status # 'X' THEN
               name[0] := 0C;
               P2MString(user.Vorname, name);
               Append(name, ' ');
               buffer[0] := 0C;
               P2MString(user.Name, buffer);
               Append(name, buffer);
               P2MString(user.Rechner, buffer);
               changed := Machine2OS(buffer);
               M2PString(buffer, user.Rechner);
            ELSE
            END;
            IF changed THEN
               IF NOT test THEN
                  (* zurckschreiben *)
                  offset := LONG(1024 (*SIZE(user)*))*LONG(CARDINAL(count));
                  Seek(file, SEEKABS, offset);
                  Write(file, ADR(user), 1024 (*SIZE(user)*), written);
                  IF verbose THEN
                     Capital(name);
                     FileIO.WriteString(outfile, name);
                     FileIO.WriteString(outfile, ' (');
                     FileIO.WriteString(outfile, buffer);
                     FileIO.WriteString(outfile, ')');
                     FileIO.WriteLine(outfile, " ... geschrieben");
                  END;
               ELSE
                  IF verbose THEN
                     Capital(name);
                     FileIO.WriteString(outfile, name);
                     FileIO.WriteString(outfile, ' (');
                     FileIO.WriteString(outfile, buffer);
                     FileIO.WriteString(outfile, ')');
                     FileIO.WriteLine(outfile, " ... wre geschrieben worden");
                  END;
               END;
            END;
         END;
         INC(count);
      UNTIL read#1024 (*SIZE(user)*);
      Close(file);
   ELSE
      FileIO.WriteString(outfile, " ! Fehler beim ffnen von ");
      FileIO.WriteLine(outfile, fileEntry.name);
   END;
END MUDATScannen;

PROCEDURE UserdatenAendern;
BEGIN
   Concat(userPath, UserFiles, path);
   DirQuery(path, Directories.NORMAL, MUDATScannen);
END UserdatenAendern;



PROCEDURE Help;
BEGIN
   FileIO.WriteLine(outfile, " syntax: mach2os  [/lock] /l /z /aX /n<Vorname Nachname> /g<Gruppe> /v /h /test");
   FileIO.WriteLn(outfile);
   FileIO.WriteLine(outfile, ' /test:           es werden keine Schreibzugriffe gemacht');
   FileIO.WriteLine(outfile, ' /v verbose:      ausfhrlichen Bericht ausgeben');
   FileIO.WriteLine(outfile, " /h help:         dieser Hilfetext wird ausgegeben");
   FileIO.WriteLn(outfile);
END Help;


TYPE     Error       =  (errWrongArgument);

PROCEDURE WriteError(err: Error);
BEGIN
   CASE err OF
   | errWrongArgument:
      FileIO.WriteLine(outfile, ' ! Falsches Argument');
   ELSE
   END;
   error := TRUE;
END WriteError;

PROCEDURE ReadCommandline;
VAR   len:  CARDINAL;
      arg:  ARRAY [0 .. 127] OF CHAR;
      ok:   BOOLEAN;
      name: ARRAY [0 .. 41] OF CHAR;
BEGIN
   GetArg(arg, len);
   WHILE arg[0]#0C DO
      CASE arg[0] OF
         '-','/':
         CASE arg[1] OF
         | 'd','D':
            Delete(arg, 0, 1);
            Upper(arg);
            IF CompareStr(arg, 'DEBUG')=0 THEN
               debug := TRUE;
            END;
         | 'h','H','?':
            help := TRUE;
            (* Help; *)
         | 't','T':
            test := TRUE;
         | 'v','V':
            verbose := TRUE;
         ELSE
            WriteError(errWrongArgument);
         END;
      ELSE
         WriteError(errWrongArgument);
      END;
      GetArg(arg, len);
   END;
END ReadCommandline;

BEGIN
   crlf[0] := CR;
   crlf[1] := LF;
   help := FALSE;
   error := FALSE;
   test := FALSE;
   verbose := FALSE;
   debug := FALSE;

   InOut.WriteString(" Mach2OS 0.1   (c) 1997  A. Mayer    ");
   GetDate(date);
   DateToStr(date, DDMMYYYY, '.', dateStr);
   InOut.WriteString(dateStr);
   InOut.WriteString("  ");
   GetTime(time);
   TimeToStr(time, H4MMSS, ':', dateStr);
   InOut.WriteLine(dateStr);
   IF NOT FileIO.Open(outfile, FileIO.STDOUT, FileIO.aWrite) THEN
      HALT;
   END;
   ReadCommandline;
   IF NOT error THEN
      IF help THEN
         Help;
      ELSE
         IF test THEN
            FileIO.WriteLine(outfile, " -test      Testmodus - es wird nichts geschrieben");
            FileIO.WriteLn(outfile);
         END;
         void.boolean := ConfigFile.Read("M7COM.CFG");
         void.boolean := ConfigFile.GetPath("UserPath", MausPath, userPath);
         CorrectPath(userPath);
         ConfigFile.Dispose;
         UserdatenAendern;
      END;
   END;
   FileIO.Close(outfile);

END Mach2OS.
